/* Standard Include Files */
#include <stdlib.h>
#include <stdio.h>

/* Constant Replacements */
#define FORT_LINE 72
#define NKEYS 27
#define MIN(x,y) (((x) <= (y)) ? (x) : (y))

/* Type definitions */
enum state_type {STANDARD,BRANCH_FIN,
			   OTHERWISE_FIN,WHEN_FIN,TO_FIN};
enum key_type {NONE,REPEAT_WHILE,REPEAT_UNTIL,DO,END,
			 CASE_SELECT,CASE_CONDITIONAL,ENDIF,FOR,
			 WHILE,UNTIL,LOOP,IF,UNLESS,WHEN,ELSE,TO,
			 CONDITIONAL,SELECT,FIN,CYCLE,EXIT,REVERT,
			 INSTANCE,OTHERWISE,PROCEDURE_CALL,IFTHEN};
struct key_stacks {
  enum key_type key;
  int line_num;
  struct key_stacks *next;
};
struct key_stacks *fin_stack,*cycle_stack;
struct line_stacks {
  char *line;
  struct line_stacks *next;
};
struct line_stacks *repeat_stack,*select_stack;

/* Global Variables */
char *keyword[NKEYS+1];
enum key_type key;
enum state_type state;
int qfortran;
int qcomment;
int qline;
int qlabel;
int qselect;
char *prog_name;
FILE *flecs;
FILE *fortran;
char *flecs_name;
char *fortran_name;
char *line;
int line_num;
int line_len;
int qcont;
int qto;
int nifthen;
int nloop;
int errnum;
char *flecs_proc;
char *error_msg;
char *scratch;

/* Function definitions */
void flecs90(char *name);
int eq(char *a,char *b);
int length(char *a);
int getline(void);
void print_line_number(int start, int num);
void echo_label(char *line);
void echo_label_continue(char *line,int line_num);
int getword(char *line,int len,int begin,int *start,int *end);
int qproc(char *line,int start,int end);
int getinstance(char *line,int len,int begin,int *start,int *end);
int key_match(char *line,int start,int end,char *key);
enum key_type getkey(char *line,int line_len,int *cur_col);
int qcontinue(char *line);
char *add_to_command(char *command,char *add,int start,int end,
		     int *command_len);
void fortran_put(char *line,int start,int end,int *fort_loc,int line_num);
void parse_cont(char *flecs_in,int flecs_len,int word_start,int word_end,
		int fort_loc,int line_num);
void finish(void);
struct key_stacks *push_key(struct key_stacks *stack,
                           enum key_type key,int line_num);
struct key_stacks *pop_key(struct key_stacks *stack);
struct line_stacks *push_line(struct line_stacks *stack,char *line,
                              int start, int finish);
struct line_stacks *pop_line(struct line_stacks *stack);

void process_standard(int cur_col);
void flecs_error(int type,char *msg,int line_num);
void quit(void);
